using System;
using System.Configuration;
using System.IO;
using System.Diagnostics;
using System.Web.Services;

[WebService(Namespace = "http://paralab.cs.vmk.unn.ru/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    public Service () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    /// <summary>
    /// Echo-,   
    /// </summary>
    /// <param name="password">   Web-</param>
    /// <returns>  </returns>
    [WebMethod]
    public string HelloParaLab(string password)
    {
        if (password == ConfigurationManager.AppSettings["password"])
        {
            return "Ok";
        }
        else
        {
            return "WrongPassword";
        }
    }

    /// <summary>
    ///     
    /// </summary>
    /// <param name="task"> </param>
    /// <param name="procNumber">  </param>
    /// <param name="dataSize">  </param>
    /// <param name="password"></param>
    /// <returns> </returns>
    [WebMethod]
    public int StartTask(string task, int procNumber, int dataSize, string password)
    {
        if (password != ConfigurationManager.AppSettings["password"])
        {
            return -1;
        }

        Random r = new Random();
        int taskId = r.Next();
        string[] CCPHosts = ConfigurationManager.AppSettings["CCPHosts"].Split(new Char[] { ',' });
        int countHosts = CCPHosts.Length;
        string hosts = "";
        int i = 0;
        while (procNumber > 0)
        {
            int tmp = Convert.ToInt32(procNumber / countHosts);
            hosts += CCPHosts[i] + " " + tmp.ToString() + " ";
            procNumber -= tmp;
            --countHosts;
            ++i;
        }
        Process.Start("job", "submit" +
            " /numprocessors:" + ConfigurationManager.AppSettings["numprocessors"] +
            " /user:" + ConfigurationManager.AppSettings["CCPUserName"] +
            " /pwd:" + ConfigurationManager.AppSettings["CCPPassword"] +
            " /workdir:" + ConfigurationManager.AppSettings["CCPSharedFolder"] +
            " mpiexec -hosts " + i.ToString() + " " + hosts +
            " " + ConfigurationManager.AppSettings["CCPSharedFolder"] +
            "\\progs\\" + task +
            " " + taskId +
            " " + dataSize);
        return taskId;
    }

    /// <summary>
    ///    
    /// </summary>
    /// <param name="taskId"> </param>
    /// <param name="password"></param>
    /// <returns>     (  ,   )</returns>
    [WebMethod]
    public int[] TaskState(int taskId, string password)
    {
        if (!File.Exists(ConfigurationManager.AppSettings["CCPSharedFolder"] + "\\stat." + taskId))
        {
            return new int[2] { 0, 1 };
        }
        StreamReader sr = File.OpenText(ConfigurationManager.AppSettings["CCPSharedFolder"] + "\\stat." + taskId);
        int currentStep = Convert.ToInt32(sr.ReadLine());
        int allSteps = Convert.ToInt32(sr.ReadLine());
        sr.Close();
        return new int[2] { currentStep, allSteps };
    }

    /// <summary>
    ///   
    /// </summary>
    /// <param name="taskId"> </param>
    /// <param name="password"></param>
    /// <returns>     (  ,    )</returns>
    [WebMethod]
    public double[] TaskResult(int taskId, string password)
    {
        StreamReader sr = File.OpenText(ConfigurationManager.AppSettings["CCPSharedFolder"] + "\\res." + taskId);
        string tmp = sr.ReadLine().Replace(".", ",");
        double allTime = Convert.ToDouble(tmp);
        tmp = sr.ReadLine().Replace(".", ",");
        double sendTime = Convert.ToDouble(tmp);
        sr.Close();
        File.Delete(ConfigurationManager.AppSettings["CCPSharedFolder"] + "\\stat." + taskId);
        File.Delete(ConfigurationManager.AppSettings["CCPSharedFolder"] + "\\res." + taskId);
        return new double[2] { allTime, sendTime };
    }
}
