#include "nettest.h"

double Chaos (int msglen, int TIMES)
{
	char *recvBuffer[512], *sendBuffer[512];
	double dTime1, dTime2, dTime, dLatency;
	MPI_Status  status;
	MPI_Status *statuses;
	MPI_Request *sendRequests, *recvRequests;
	int pool_size,rank,remote,i_am_the_master;
	int i,j;
	double Rate;

	MPI_Comm_size(comm, &pool_size);
	MPI_Comm_rank(comm, &rank);

	i_am_the_master = (rank == 0) ? 1 : 0;

	statuses     = (MPI_Status *) malloc (pool_size * sizeof(MPI_Status) );
   	sendRequests = (MPI_Request *) malloc (pool_size * sizeof(MPI_Request) );
   	recvRequests = (MPI_Request *) malloc (pool_size * sizeof(MPI_Request) );

	for(i = 0; i < pool_size; i ++) 
	{
		recvBuffer[i] = (char*) malloc(msglen);		
		sendBuffer[i] = (char*) malloc(msglen);
		if(recvBuffer[i] == NULL || sendBuffer[i] == NULL)
			finish("Can't allocate buffer");
	}
 
	MPI_Barrier(comm);

	msglen = msglen;
	dTime1 = Wtime();

	for(i = 0; i < TIMES; i ++)
	{
		for(remote = rank + 1; remote < pool_size; remote ++)
			MPI_Isend(sendBuffer[remote],msglen,MPI_CHAR,remote,iTAG,comm,&sendRequests[remote]);

		for(remote = 0; remote < pool_size; remote ++)
			if(remote != rank)
				MPI_Irecv(recvBuffer[remote],msglen,MPI_CHAR,remote,iTAG,comm,&recvRequests[remote]);

		recvRequests[rank] = MPI_REQUEST_NULL;
		sendRequests[rank] = MPI_REQUEST_NULL;

		for(j = 0; j < pool_size - 1; j ++) 
		{
			MPI_Waitany(pool_size,recvRequests,&remote,&status);
			if(remote == MPI_UNDEFINED)
				finish("Undefined return code of MPI_Waitany");
			if(remote < rank)
				MPI_Isend(sendBuffer[remote],msglen,MPI_CHAR,remote,iTAG,comm,&sendRequests[remote]);
		}

		MPI_Waitall(pool_size,sendRequests,statuses);	
	} /* End of iterations */

		MPI_Barrier(comm);
		dTime2 = Wtime ( ); /* Timing for iMyRank = iROOT */
		dTime = dTime2 - dTime1;


	    /*  Compute transfer rate   */
		Rate = ((double) msglen * 2.0 * TIMES) / (dTime);

	for(i = 0; i < pool_size; i ++) 
	{
		free(recvBuffer[i]);		
		free(sendBuffer[i]);
	}

	free(statuses);
	free(sendRequests);
	free(recvRequests);
		
   return Rate;

} /* End of function Chaos ( ) */


